<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Global - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="install.html">install</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="install.html#.install_as_user">install_as_user</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_as_developer">install_as_developer</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_a_new_package">install_a_new_package</a></li></ul></li><li><a href="make.html">make</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="make.html#.build">build</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_cpp">build_cpp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_gyp">build_gyp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_python">build_python</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_public">build_public</a></li><li data-type='method' style='display: none;'><a href="make.html#.test">test</a></li><li data-type='method' style='display: none;'><a href="make.html#.clean">clean</a></li><li data-type='method' style='display: none;'><a href="make.html#.sync">sync</a></li><li data-type='method' style='display: none;'><a href="make.html#.show">show</a></li><li data-type='method' style='display: none;'><a href="make.html#.usage">usage</a></li><li data-type='method' style='display: none;'><a href="make.html#.install">install</a></li></ul></li><li><a href="jsdoc2.html">jsdoc2</a></li></ul><h3>Global</h3><ul><li><a href="global.html#make-readme">make-readme</a></li><li><a href="global.html#menu">menu</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">Global</h1>
    

    




<section>

<header>
    
        <h2>
        
            
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

<dl class="details">
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>




            

            
        
        </div>
    

    

    

    
    
    

     

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="make-readme"><span class="type-signature type-signature-static">(static) </span>make-readme<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Command line builder of the README.md file from the package.json file for aidebuild</p>
<pre class="prettyprint source"><code>    Usage: ./src/make-readme.js
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id="menu"><span class="type-signature type-signature-static">(static) </span>menu<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Generates a simple graphical user interface menu for the commands.</p>
<pre class="prettyprint source"><code>    Usage: .../aidebuild/src/menu.js  [--term] [menu.json] &
     --term: runs in current terminal instead of opening a pop-up window.
</code></pre>
<ul>
<li>It requires a <code>menu.json</code> file defining the shell commands to be run, e.g. :</li>
</ul>
<pre class="prettyprint source"><code>{
  &quot; rebuild&quot;: &quot;make rebuild what=ongoing&quot;,
  &quot; clean&quot;:   &quot;make clean&quot;,
  &quot;console&quot;:  &quot;mate-terminal&quot;,
  &quot;suspend&quot;:  &quot;sudo systemctl suspend&quot;
}
</code></pre>
<ul>
<li>
<p>Usage notes:</p>
<ul>
<li>By convention, in the <code>menu.json</code> file:
<ul>
<li>command names starting with a space, e.g. <code>&quot; rebuild&quot;</code> or <code>&quot; clean&quot;</code> are run in a terminal,</li>
<li>others are run in background.</li>
</ul>
</li>
<li>By default, <code>./menu.json</code>, else <code>.../aidebuild/src/menu.json</code>, is considered.</li>
<li>The menu title is built from:
<ul>
<li>the current directory base-name (not considering <code>.../src/</code> or <code>.../main/</code> suffix),</li>
<li>followed by the <code>menu.json</code> base-name (without extension, and if not equal to the word <code>menu</code>).</li>
</ul>
</li>
</ul>
</li>
<li>
<p>Implementation notes:</p>
<ul>
<li>It requires a manual call of <code>npm install cligui2</code> on install.</li>
<li>The menu is generated using a <code>xterm</code> terminal graphic functionalities, yielding a menu of the form:
<img src="./menu.png" alt="menu"></li>
<li>It does not require any specific GUI and it is usable on any platform.</li>
<li>It uses the <a href="https://www.npmjs.com/package/cligui2">cligui2</a> clever middle-ware.</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>